//
//  TableExampleViewController.m
//  TableExample
//
//  Created by Neil Smyth on 7/8/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "TableExampleViewController.h"

@implementation TableExampleViewController
@synthesize colorNames;

// Customize the number of rows in the table view.
// 테이블의 뷰의 행의 개수를 리턴한다.
- (NSInteger)tableView:(UITableView *)tableView 
 numberOfRowsInSection:(NSInteger)section {
    return [self.colorNames count];
}

// Customize the appearance of table view cells.
//테이블 뷰 셀의 화면을 변경한다.
- (UITableViewCell *)tableView:(UITableView *)tableView 
         cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
        static NSString *CellIdentifier = @"Cell";
        
        UITableViewCell *cell = [tableView 
                                 dequeueReusableCellWithIdentifier:CellIdentifier];
        if (cell == nil) {
            cell = [[UITableViewCell alloc]
                     initWithStyle:UITableViewCellStyleSubtitle
                     reuseIdentifier:CellIdentifier];
        }
        
        // Configure the cell.
        //이미지 파일로부터 uiimage 오브젝트를 만든 다음, 이를 셀 오브젝트의 imageview 속성에 할당한다.
        UIImage *cellImage = [UIImage imageNamed:@"apple.png"];
        cell.imageView.image = cellImage;
        NSString *colorString = [self.colorNames 
                                 objectAtIndex: [indexPath row]];
        
        cell.textLabel.text = colorString;
    
        //셀의 부재를 추가한다.
        NSString *subtitle = [NSString stringWithString: 
                              @"All about the color "];
    
        //셀 부재값 + 칼라명을  stringbyappendingstring 을 통해 추가한다.
        subtitle = [subtitle stringByAppendingString:colorString];
        //셀 오브젝트의 detailTextLabel 속성에 문자열을 할당함으로 처리한다.
        cell.detailTextLabel.text = subtitle;
        return cell;
    } 

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    //배열의 메모리를 할당하고, 초기화 한 다음에 배열을 할당한다.
    self.colorNames = [[NSArray alloc] 
                       initWithObjects:@"Red", @"Green",
                       @"Blue", @"Indigo", @"Violet", nil];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    //배열이 더 이상 필요하지 않으면, 메모리를 해제한다.
    self.colorNames = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

@end
